Package org.eclipse.jdt.core.dom

# Class ASTNode

java.lang.Object
org.eclipse.jdt.core.dom.ASTNode

Direct Known Subclasses:
  `AbstractTagElement`, `AbstractTextElement`, `AnonymousClassDeclaration`, `BodyDeclaration`, `CatchClause`, `Comment`, `CompilationUnit`, `Dimension`, `Expression`, `ImportDeclaration`, `MemberRef`, `MemberValuePair`, `MethodRef`, `MethodRefParameter`, `Modifier`, `ModuleDeclaration`, `ModuleDirective`, `ModuleModifier`, `PackageDeclaration`, `Statement`, `TagProperty`, `Type`, `TypeParameter`, `VariableDeclaration`

public abstract class ASTNode extends Object
Abstract superclass of all Abstract Syntax Tree (AST) node types.

An AST node represents a Java source code construct, such as a name, type, expression, statement, or declaration.

Each AST node belongs to a unique AST instance, called the owning AST. The children of an AST node always have the same owner as their parent node. If a node from one AST is to be added to a different AST, the subtree must be cloned first to ensure that the added nodes have the correct owning AST.

When an AST node is part of an AST, it has a unique parent node. Clients can navigate upwards, from child to parent, as well as downwards, from parent to child. Newly created nodes are unparented. When an unparented node is set as a child of a node (using a `setCHILD` method), its parent link is set automatically and the parent link of the former child is set to `null`. For nodes with properties that include a list of children (for example, `Block` whose `statements` property is a list of statements), adding or removing an element to/for the list property automatically updates the parent links. These lists support the `List.set` method; however, the constraint that the same node cannot appear more than once means that this method cannot be used to swap elements without first removing the node.

ASTs must not contain cycles. All operations that could create a cycle detect this possibility and fail.

ASTs do not contain "holes" (missing subtrees). If a node is required to have a certain property, a syntactically plausible initial value is always supplied.

The hierarchy of AST node types has some convenient groupings marked by abstract superclasses:

- expressions - `Expression`
- names - `Name` (a sub-kind of expression)
- statements - `Statement`
- types - `Type`
- type body declarations - `BodyDeclaration`

Abstract syntax trees may be hand constructed by clients, using the `newTYPE` factory methods (see `AST`) to create new nodes, and the various `setCHILD` methods to connect them together.

The class `ASTParser` parses a string containing a Java source code and returns an abstract syntax tree for it. The resulting nodes carry source ranges relating the node back to the original source characters. The source range covers the construct as a whole.

Each AST node carries bit flags, which may convey additional information about the node. For instance, the parser uses a flag to indicate a syntax error. Newly created nodes have no flags set.

Each AST node is capable of carrying an open-ended collection of client-defined properties. Newly created nodes have none. `getProperty` and `setProperty` are used to access these properties.

AST nodes are thread-safe for readers provided there are no active writers. If one thread is modifying an AST, including creating new nodes or cloning existing ones, it is not safe for another thread to read, visit, write, create, or clone any of the nodes on the same AST. When synchronization is required, consider using the common AST object that owns the node; that is, use `synchronize (node.getAST()) {...}`.

ASTs also support the visitor pattern; see the class `ASTVisitor` for details. The `NodeFinder` class can be used to find a specific node inside a tree.

Compilation units created by `ASTParser` from a source document can be serialized after arbitrary modifications with minimal loss of original formatting. See `CompilationUnit.recordModifications()` for details. See also `ASTRewrite` for an alternative way to describe and serialize changes to a read-only AST.

Since:
  2.0
See Also:
  - `ASTParser`
  - `ASTVisitor`
  - `NodeFinder`
Restriction:
  This class is not intended to be subclassed by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ANNOTATION_TYPE_DECLARATION`
Node type constant indicating a node of type `AnnotationTypeDeclaration`.
`static final int`
`ANNOTATION_TYPE_MEMBER_DECLARATION`
Node type constant indicating a node of type `AnnotationTypeMemberDeclaration`.
`static final int`
`ANONYMOUS_CLASS_DECLARATION`
Node type constant indicating a node of type `AnonymousClassDeclaration`.
`static final int`
`ARRAY_ACCESS`
Node type constant indicating a node of type `ArrayAccess`.
`static final int`
`ARRAY_CREATION`
Node type constant indicating a node of type `ArrayCreation`.
`static final int`
`ARRAY_INITIALIZER`
Node type constant indicating a node of type `ArrayInitializer`.
`static final int`
`ARRAY_TYPE`
Node type constant indicating a node of type `ArrayType`.
`static final int`
`ASSERT_STATEMENT`
Node type constant indicating a node of type `AssertStatement`.
`static final int`
`ASSIGNMENT`
Node type constant indicating a node of type `Assignment`.
`static final int`
`BLOCK`
Node type constant indicating a node of type `Block`.
`static final int`
`BLOCK_COMMENT`
Node type constant indicating a node of type `BlockComment`.
`static final int`
`BOOLEAN_LITERAL`
Node type constant indicating a node of type `BooleanLiteral`.
`static final int`
`BREAK_STATEMENT`
Node type constant indicating a node of type `BreakStatement`.
`static final int`
`CASE_DEFAULT_EXPRESSION`
Node type constant indicating a node of type `CaseDefaultExpression`.
`static final int`
`CAST_EXPRESSION`
Node type constant indicating a node of type `CastExpression`.
`static final int`
`CATCH_CLAUSE`
Node type constant indicating a node of type `CatchClause`.
`static final int`
`CHARACTER_LITERAL`
Node type constant indicating a node of type `CharacterLiteral`.
`static final int`
`CLASS_INSTANCE_CREATION`
Node type constant indicating a node of type `ClassInstanceCreation`.
`static final int`
`COMPILATION_UNIT`
Node type constant indicating a node of type `CompilationUnit`.
`static final int`
`CONDITIONAL_EXPRESSION`
Node type constant indicating a node of type `ConditionalExpression`.
`static final int`
`CONSTRUCTOR_INVOCATION`
Node type constant indicating a node of type `ConstructorInvocation`.
`static final int`
`CONTINUE_STATEMENT`
Node type constant indicating a node of type `ContinueStatement`.
`static final int`
`CREATION_REFERENCE`
Node type constant indicating a node of type `CreationReference`.
`static final int`
`DIMENSION`
Node type constant indicating a node of type `Dimension`.
`static final int`
`DO_STATEMENT`
Node type constant indicating a node of type `DoStatement`.
`static final int`
`EitherOr_MultiPattern`
Node type constant indicating a node of type `EitherOrMultiPattern`.
`static final int`
`EMPTY_STATEMENT`
Node type constant indicating a node of type `EmptyStatement`.
`static final int`
`ENHANCED_FOR_STATEMENT`
Node type constant indicating a node of type `EnhancedForStatement`.
`static final int`
`ENUM_CONSTANT_DECLARATION`
Node type constant indicating a node of type `EnumConstantDeclaration`.
`static final int`
`ENUM_DECLARATION`
Node type constant indicating a node of type `EnumDeclaration`.
`static final int`
`EXPORTS_DIRECTIVE`
Node type constant indicating a node of type `ExportsDirective`.
`static final int`
`EXPRESSION_METHOD_REFERENCE`
Node type constant indicating a node of type `ExpressionMethodReference`.
`static final int`
`EXPRESSION_STATEMENT`
Node type constant indicating a node of type `ExpressionStatement`.
`static final int`
`FIELD_ACCESS`
Node type constant indicating a node of type `FieldAccess`.
`static final int`
`FIELD_DECLARATION`
Node type constant indicating a node of type `FieldDeclaration`.
`static final int`
`FOR_STATEMENT`
Node type constant indicating a node of type `ForStatement`.
`static final int`
`GUARDED_PATTERN`
Node type constant indicating a node of type `GuardedPattern`.
`static final int`
`IF_STATEMENT`
Node type constant indicating a node of type `IfStatement`.
`static final int`
`IMPORT_DECLARATION`
Node type constant indicating a node of type `ImportDeclaration`.
`static final int`
`INFIX_EXPRESSION`
Node type constant indicating a node of type `InfixExpression`.
`static final int`
`INITIALIZER`
Node type constant indicating a node of type `Initializer`.
`static final int`
`INSTANCEOF_EXPRESSION`
Node type constant indicating a node of type `InstanceofExpression`.
`static final int`
`INTERSECTION_TYPE`
Node type constant indicating a node of type `IntersectionType`.
`static final int`
`JAVADOC`
Node type constant indicating a node of type `Javadoc`.
`static final int`
`JAVADOC_REGION`
Node type constant indicating a node of type `JavaDocRegion`.
`static final int`
`JAVADOC_TEXT_ELEMENT`
Node type constant indicating a node of type `TextElement`.
`static final int`
`LABELED_STATEMENT`
Node type constant indicating a node of type `LabeledStatement`.
`static final int`
`LAMBDA_EXPRESSION`
Node type constant indicating a node of type `LambdaExpression`.
`static final int`
`LINE_COMMENT`
Node type constant indicating a node of type `LineComment`.
`static final int`
`MALFORMED`
Flag constant (bit mask, value 1) indicating that there is something not quite right with this AST node.
`static final int`
`MARKER_ANNOTATION`
Node type constant indicating a node of type `MarkerAnnotation`.
`static final int`
`MEMBER_REF`
Node type constant indicating a node of type `MemberRef`.
`static final int`
`MEMBER_VALUE_PAIR`
Node type constant indicating a node of type `MemberValuePair`.
`static final int`
`METHOD_DECLARATION`
Node type constant indicating a node of type `MethodDeclaration`.
`static final int`
`METHOD_INVOCATION`
Node type constant indicating a node of type `MethodInvocation`.
`static final int`
`METHOD_REF`
Node type constant indicating a node of type `MethodRef`.
`static final int`
`METHOD_REF_PARAMETER`
Node type constant indicating a node of type `MethodRefParameter`.
`static final int`
`MODIFIER`
Node type constant indicating a node of type `Modifier`.
`static final int`
`MODULE_DECLARATION`
Node type constant indicating a node of type `ModuleDeclaration`.
`static final int`
`MODULE_MODIFIER`
Node type constant indicating a node of type `ModuleModifier`.
`static final int`
`MODULE_QUALIFIED_NAME`
Node type constant indicating a node of type `ModuleQualifiedName`.
`static final int`
`NAME_QUALIFIED_TYPE`
Node type constant indicating a node of type `NameQualifiedType`.
`static final int`
`NORMAL_ANNOTATION`
Node type constant indicating a node of type `NormalAnnotation`.
`static final int`
`NULL_LITERAL`
Node type constant indicating a node of type `NullLiteral`.
`static final int`
`NULL_PATTERN`
Node type constant indicating a node of type `NullPattern`.
`static final int`
`NUMBER_LITERAL`
Node type constant indicating a node of type `NumberLiteral`.
`static final int`
`OPENS_DIRECTIVE`
Node type constant indicating a node of type `OpensDirective`.
`static final int`
`ORIGINAL`
Flag constant (bit mask, value 2) indicating that this is a node that was created by the parser (as opposed to one created by another party).
`static final int`
`PACKAGE_DECLARATION`
Node type constant indicating a node of type `PackageDeclaration`.
`static final int`
`PARAMETERIZED_TYPE`
Node type constant indicating a node of type `ParameterizedType`.
`static final int`
`PARENTHESIZED_EXPRESSION`
Node type constant indicating a node of type `ParenthesizedExpression`.
`static final int`
`PATTERN_INSTANCEOF_EXPRESSION`
Node type constant indicating a node of type `PatternInstanceofExpression`.
`static final int`
`POSTFIX_EXPRESSION`
Node type constant indicating a node of type `PostfixExpression`.
`static final int`
`PREFIX_EXPRESSION`
Node type constant indicating a node of type `PrefixExpression`.
`static final int`
`PRIMITIVE_TYPE`
Node type constant indicating a node of type `PrimitiveType`.
`static final int`
`PROTECT`
Flag constant (bit mask, value 4) indicating that this node is unmodifiable.
`static final int`
`PROVIDES_DIRECTIVE`
Node type constant indicating a node of type `ProvidesDirective`.
`static final int`
`QUALIFIED_NAME`
Node type constant indicating a node of type `QualifiedName`.
`static final int`
`QUALIFIED_TYPE`
Node type constant indicating a node of type `QualifiedType`.
`static final int`
`RECORD_DECLARATION`
Node type constant indicating a node of type `RecordDeclaration`.
`static final int`
`RECORD_PATTERN`
Node type constant indicating a node of type `RecordPattern`.
`static final int`
`RECOVERED`
Flag constant (bit mask, value 8) indicating that this node or a part of this node is recovered from source that contains a syntax error detected in the vicinity.
`static final int`
`REQUIRES_DIRECTIVE`
Node type constant indicating a node of type `RequiresDirective`.
`static final int`
`RETURN_STATEMENT`
Node type constant indicating a node of type `ReturnStatement`.
`static final int`
`SIMPLE_NAME`
Node type constant indicating a node of type `SimpleName`.
`static final int`
`SIMPLE_TYPE`
Node type constant indicating a node of type `SimpleType`.
`static final int`
`SINGLE_MEMBER_ANNOTATION`
Node type constant indicating a node of type `SingleMemberAnnotation`.
`static final int`
`SINGLE_VARIABLE_DECLARATION`
Node type constant indicating a node of type `SingleVariableDeclaration`.
`static final int`
`STRING_FRAGMENT`
Node type constant indicating a node of type `StringFragment`.
`static final int`
`STRING_LITERAL`
Node type constant indicating a node of type `StringLiteral`.
`static final int`
`STRING_TEMPLATE_COMPONENT`
Node type constant indicating a node of type `StringTemplateComponent`.
`static final int`
`STRING_TEMPLATE_EXPRESSION`
Node type constant indicating a node of type `StringTemplateExpression`.
`static final int`
`SUPER_CONSTRUCTOR_INVOCATION`
Node type constant indicating a node of type `SuperConstructorInvocation`.
`static final int`
`SUPER_FIELD_ACCESS`
Node type constant indicating a node of type `SuperFieldAccess`.
`static final int`
`SUPER_METHOD_INVOCATION`
Node type constant indicating a node of type `SuperMethodInvocation`.
`static final int`
`SUPER_METHOD_REFERENCE`
Node type constant indicating a node of type `SuperMethhodReference`.
`static final int`
`SWITCH_CASE`
Node type constant indicating a node of type `SwitchCase`.
`static final int`
`SWITCH_EXPRESSION`
Node type constant indicating a node of type `SwitchExpression`.
`static final int`
`SWITCH_STATEMENT`
Node type constant indicating a node of type `SwitchStatement`.
`static final int`
`SYNCHRONIZED_STATEMENT`
Node type constant indicating a node of type `SynchronizedStatement`.
`static final int`
`TAG_ELEMENT`
Node type constant indicating a node of type `TagElement`.
`static final int`
`TAG_PROPERTY`
Node type constant indicating a node of type `TagProperty`.
`static final int`
`TEXT_BLOCK`
Node type constant indicating a node of type `TextBlock`.
`static final int`
`TEXT_ELEMENT`
Node type constant indicating a node of type `TextElement`.
`static final int`
`THIS_EXPRESSION`
Node type constant indicating a node of type `ThisExpression`.
`static final int`
`THROW_STATEMENT`
Node type constant indicating a node of type `ThrowStatement`.
`static final int`
`TRY_STATEMENT`
Node type constant indicating a node of type `TryStatement`.
`static final int`
`TYPE_DECLARATION`
Node type constant indicating a node of type `TypeDeclaration`.
`static final int`
`TYPE_DECLARATION_STATEMENT`
Node type constant indicating a node of type `TypeDeclarationStatement`.
`static final int`
`TYPE_LITERAL`
Node type constant indicating a node of type `TypeLiteral`.
`static final int`
`TYPE_METHOD_REFERENCE`
Node type constant indicating a node of type `TypeMethodReference`.
`static final int`
`TYPE_PARAMETER`
Node type constant indicating a node of type `TypeParameter`.
`static final int`
`TYPE_PATTERN`
Node type constant indicating a node of type `TypePattern`.
`static final int`
`UNION_TYPE`
Node type constant indicating a node of type `UnionType`.
`static final int`
`UNNAMED_CLASS`
`static final int`
`USES_DIRECTIVE`
Node type constant indicating a node of type `UsesDirective`.
`static final int`
`VARIABLE_DECLARATION_EXPRESSION`
Node type constant indicating a node of type `VariableDeclarationExpression`.
`static final int`
`VARIABLE_DECLARATION_FRAGMENT`
Node type constant indicating a node of type `VariableDeclarationFragment`.
`static final int`
`VARIABLE_DECLARATION_STATEMENT`
Node type constant indicating a node of type `VariableDeclarationStatement`.
`static final int`
`WHILE_STATEMENT`
Node type constant indicating a node of type `WhileStatement`.
`static final int`
`WILDCARD_TYPE`
Node type constant indicating a node of type `WildcardType`.
`static final int`
`YIELD_STATEMENT`
Node type constant indicating a node of type `YieldStatement`.

## Method Summary

Modifier and Type
Method
Description
`final void`
`accept(ASTVisitor visitor)`
Accepts the given visitor on a visit of the current node.
`static ASTNode`
`copySubtree(AST target, ASTNode node)`
Returns a deep copy of the subtree of AST nodes rooted at the given node.
`static List`
`copySubtrees(AST target, List nodes)`
Returns a deep copy of the subtrees of AST nodes rooted at the given list of nodes.
`final void`
`delete()`
Removes this node from its parent.
`final boolean`
`equals(Object obj)`
The `ASTNode` implementation of this `Object` method uses object identity (==).
`final AST`
`getAST()`
Returns this node's AST.
`final int`
`getFlags()`
Returns the flags associated with this node.
`final int`
`getLength()`
Returns the length in characters of the original source file indicating where the source fragment corresponding to this node ends.
`final StructuralPropertyDescriptor`
`getLocationInParent()`
Returns the location of this node within its parent, or `null` if this is a root node.
`final int`
`getNodeType()`
Returns an integer value identifying the type of this concrete AST node.
`final ASTNode`
`getParent()`
Returns this node's parent node, or `null` if this is the root node.
`final Object`
`getProperty(String propertyName)`
Returns the value of the named property of this node, or `null` if none.
`final ASTNode`
`getRoot()`
Returns the root node at or above this node; returns this node if it is a root.
`final int`
`getStartPosition()`
Returns the character index into the original source file indicating where the source fragment corresponding to this node begins.
`final Object`
`getStructuralProperty(StructuralPropertyDescriptor property)`
Returns the value of the given structural property for this node.
`final int`
`hashCode()`
`static Class`
`nodeClassForType(int nodeType)`
Returns the node class for the corresponding node type.
`final Map`
`properties()`
Returns an unmodifiable table of the properties of this node with non-`null` values.
`final void`
`setFlags(int flags)`
Sets the flags associated with this node to the given value.
`final void`
`setProperty(String propertyName, Object data)`
Sets the named property of this node to the given value, or to `null` to clear it.
`final void`
`setSourceRange(int startPosition, int length)`
Sets the source range of the original source file where the source fragment corresponding to this node was found.
`final void`
`setStructuralProperty(StructuralPropertyDescriptor property, Object value)`
Sets the value of the given structural property for this node.
`final List`
`structuralPropertiesForType()`
Returns a list of structural property descriptors for nodes of the same type as this node.
`final int`
`subtreeBytes()`
Returns an estimate of the memory footprint in bytes of the entire subtree rooted at this node.
`final boolean`
`subtreeMatch(ASTMatcher matcher, Object other)`
Returns whether the subtree rooted at the given node matches the given other object as decided by the given matcher.
`final String`
`toString()`
Returns a string representation of this node suitable for debugging purposes only.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### ANONYMOUS_CLASS_DECLARATION

public static final int ANONYMOUS_CLASS_DECLARATION
Node type constant indicating a node of type `AnonymousClassDeclaration`.

See Also:
  - `AnonymousClassDeclaration`
  - Constant Field Values

### ARRAY_ACCESS

public static final int ARRAY_ACCESS
Node type constant indicating a node of type `ArrayAccess`.

See Also:
  - `ArrayAccess`
  - Constant Field Values

### ARRAY_CREATION

public static final int ARRAY_CREATION
Node type constant indicating a node of type `ArrayCreation`.

See Also:
  - `ArrayCreation`
  - Constant Field Values

### ARRAY_INITIALIZER

public static final int ARRAY_INITIALIZER
Node type constant indicating a node of type `ArrayInitializer`.

See Also:
  - `ArrayInitializer`
  - Constant Field Values

### ARRAY_TYPE

public static final int ARRAY_TYPE
Node type constant indicating a node of type `ArrayType`.

See Also:
  - `ArrayType`
  - Constant Field Values

### ASSERT_STATEMENT

public static final int ASSERT_STATEMENT
Node type constant indicating a node of type `AssertStatement`.

See Also:
  - `AssertStatement`
  - Constant Field Values

### ASSIGNMENT

public static final int ASSIGNMENT
Node type constant indicating a node of type `Assignment`.

See Also:
  - `Assignment`
  - Constant Field Values

### BLOCK

public static final int BLOCK
Node type constant indicating a node of type `Block`.

See Also:
  - `Block`
  - Constant Field Values

### BOOLEAN_LITERAL

public static final int BOOLEAN_LITERAL
Node type constant indicating a node of type `BooleanLiteral`.

See Also:
  - `BooleanLiteral`
  - Constant Field Values

### BREAK_STATEMENT

public static final int BREAK_STATEMENT
Node type constant indicating a node of type `BreakStatement`.

See Also:
  - `BreakStatement`
  - Constant Field Values

### CAST_EXPRESSION

public static final int CAST_EXPRESSION
Node type constant indicating a node of type `CastExpression`.

See Also:
  - `CastExpression`
  - Constant Field Values

### CATCH_CLAUSE

public static final int CATCH_CLAUSE
Node type constant indicating a node of type `CatchClause`.

See Also:
  - `CatchClause`
  - Constant Field Values

### CHARACTER_LITERAL

public static final int CHARACTER_LITERAL
Node type constant indicating a node of type `CharacterLiteral`.

See Also:
  - `CharacterLiteral`
  - Constant Field Values

### CLASS_INSTANCE_CREATION

public static final int CLASS_INSTANCE_CREATION
Node type constant indicating a node of type `ClassInstanceCreation`.

See Also:
  - `ClassInstanceCreation`
  - Constant Field Values

### COMPILATION_UNIT

public static final int COMPILATION_UNIT
Node type constant indicating a node of type `CompilationUnit`.

See Also:
  - `CompilationUnit`
  - Constant Field Values

### CONDITIONAL_EXPRESSION

public static final int CONDITIONAL_EXPRESSION
Node type constant indicating a node of type `ConditionalExpression`.

See Also:
  - `ConditionalExpression`
  - Constant Field Values

### CONSTRUCTOR_INVOCATION

public static final int CONSTRUCTOR_INVOCATION
Node type constant indicating a node of type `ConstructorInvocation`.

See Also:
  - `ConstructorInvocation`
  - Constant Field Values

### CONTINUE_STATEMENT

public static final int CONTINUE_STATEMENT
Node type constant indicating a node of type `ContinueStatement`.

See Also:
  - `ContinueStatement`
  - Constant Field Values

### DO_STATEMENT

public static final int DO_STATEMENT
Node type constant indicating a node of type `DoStatement`.

See Also:
  - `DoStatement`
  - Constant Field Values

### EMPTY_STATEMENT

public static final int EMPTY_STATEMENT
Node type constant indicating a node of type `EmptyStatement`.

See Also:
  - `EmptyStatement`
  - Constant Field Values

### EXPRESSION_STATEMENT

public static final int EXPRESSION_STATEMENT
Node type constant indicating a node of type `ExpressionStatement`.

See Also:
  - `ExpressionStatement`
  - Constant Field Values

### FIELD_ACCESS

public static final int FIELD_ACCESS
Node type constant indicating a node of type `FieldAccess`.

See Also:
  - `FieldAccess`
  - Constant Field Values

### FIELD_DECLARATION

public static final int FIELD_DECLARATION
Node type constant indicating a node of type `FieldDeclaration`.

See Also:
  - `FieldDeclaration`
  - Constant Field Values

### FOR_STATEMENT

public static final int FOR_STATEMENT
Node type constant indicating a node of type `ForStatement`.

See Also:
  - `ForStatement`
  - Constant Field Values

### IF_STATEMENT

public static final int IF_STATEMENT
Node type constant indicating a node of type `IfStatement`.

See Also:
  - `IfStatement`
  - Constant Field Values

### IMPORT_DECLARATION

public static final int IMPORT_DECLARATION
Node type constant indicating a node of type `ImportDeclaration`.

See Also:
  - `ImportDeclaration`
  - Constant Field Values

### INFIX_EXPRESSION

public static final int INFIX_EXPRESSION
Node type constant indicating a node of type `InfixExpression`.

See Also:
  - `InfixExpression`
  - Constant Field Values

### INITIALIZER

public static final int INITIALIZER
Node type constant indicating a node of type `Initializer`.

See Also:
  - `Initializer`
  - Constant Field Values

### JAVADOC

public static final int JAVADOC
Node type constant indicating a node of type `Javadoc`.

See Also:
  - `Javadoc`
  - Constant Field Values

### LABELED_STATEMENT

public static final int LABELED_STATEMENT
Node type constant indicating a node of type `LabeledStatement`.

See Also:
  - `LabeledStatement`
  - Constant Field Values

### METHOD_DECLARATION

public static final int METHOD_DECLARATION
Node type constant indicating a node of type `MethodDeclaration`.

See Also:
  - `MethodDeclaration`
  - Constant Field Values

### METHOD_INVOCATION

public static final int METHOD_INVOCATION
Node type constant indicating a node of type `MethodInvocation`.

See Also:
  - `MethodInvocation`
  - Constant Field Values

### NULL_LITERAL

public static final int NULL_LITERAL
Node type constant indicating a node of type `NullLiteral`.

See Also:
  - `NullLiteral`
  - Constant Field Values

### NUMBER_LITERAL

public static final int NUMBER_LITERAL
Node type constant indicating a node of type `NumberLiteral`.

See Also:
  - `NumberLiteral`
  - Constant Field Values

### PACKAGE_DECLARATION

public static final int PACKAGE_DECLARATION
Node type constant indicating a node of type `PackageDeclaration`.

See Also:
  - `PackageDeclaration`
  - Constant Field Values

### PARENTHESIZED_EXPRESSION

public static final int PARENTHESIZED_EXPRESSION
Node type constant indicating a node of type `ParenthesizedExpression`.

See Also:
  - `ParenthesizedExpression`
  - Constant Field Values

### POSTFIX_EXPRESSION

public static final int POSTFIX_EXPRESSION
Node type constant indicating a node of type `PostfixExpression`.

See Also:
  - `PostfixExpression`
  - Constant Field Values

### PREFIX_EXPRESSION

public static final int PREFIX_EXPRESSION
Node type constant indicating a node of type `PrefixExpression`.

See Also:
  - `PrefixExpression`
  - Constant Field Values

### PRIMITIVE_TYPE

public static final int PRIMITIVE_TYPE
Node type constant indicating a node of type `PrimitiveType`.

See Also:
  - `PrimitiveType`
  - Constant Field Values

### QUALIFIED_NAME

public static final int QUALIFIED_NAME
Node type constant indicating a node of type `QualifiedName`.

See Also:
  - `QualifiedName`
  - Constant Field Values

### RETURN_STATEMENT

public static final int RETURN_STATEMENT
Node type constant indicating a node of type `ReturnStatement`.

See Also:
  - `ReturnStatement`
  - Constant Field Values

### SIMPLE_NAME

public static final int SIMPLE_NAME
Node type constant indicating a node of type `SimpleName`.

See Also:
  - `SimpleName`
  - Constant Field Values

### SIMPLE_TYPE

public static final int SIMPLE_TYPE
Node type constant indicating a node of type `SimpleType`.

See Also:
  - `SimpleType`
  - Constant Field Values

### SINGLE_VARIABLE_DECLARATION

public static final int SINGLE_VARIABLE_DECLARATION
Node type constant indicating a node of type `SingleVariableDeclaration`.

See Also:
  - `SingleVariableDeclaration`
  - Constant Field Values

### STRING_LITERAL

public static final int STRING_LITERAL
Node type constant indicating a node of type `StringLiteral`.

See Also:
  - `StringLiteral`
  - Constant Field Values

### SUPER_CONSTRUCTOR_INVOCATION

public static final int SUPER_CONSTRUCTOR_INVOCATION
Node type constant indicating a node of type `SuperConstructorInvocation`.

See Also:
  - `SuperConstructorInvocation`
  - Constant Field Values

### SUPER_FIELD_ACCESS

public static final int SUPER_FIELD_ACCESS
Node type constant indicating a node of type `SuperFieldAccess`.

See Also:
  - `SuperFieldAccess`
  - Constant Field Values

### SUPER_METHOD_INVOCATION

public static final int SUPER_METHOD_INVOCATION
Node type constant indicating a node of type `SuperMethodInvocation`.

See Also:
  - `SuperMethodInvocation`
  - Constant Field Values

### SWITCH_CASE

public static final int SWITCH_CASE
Node type constant indicating a node of type `SwitchCase`.

See Also:
  - `SwitchCase`
  - Constant Field Values

### SWITCH_STATEMENT

public static final int SWITCH_STATEMENT
Node type constant indicating a node of type `SwitchStatement`.

See Also:
  - `SwitchStatement`
  - Constant Field Values

### SYNCHRONIZED_STATEMENT

public static final int SYNCHRONIZED_STATEMENT
Node type constant indicating a node of type `SynchronizedStatement`.

See Also:
  - `SynchronizedStatement`
  - Constant Field Values

### THIS_EXPRESSION

public static final int THIS_EXPRESSION
Node type constant indicating a node of type `ThisExpression`.

See Also:
  - `ThisExpression`
  - Constant Field Values

### THROW_STATEMENT

public static final int THROW_STATEMENT
Node type constant indicating a node of type `ThrowStatement`.

See Also:
  - `ThrowStatement`
  - Constant Field Values

### TRY_STATEMENT

public static final int TRY_STATEMENT
Node type constant indicating a node of type `TryStatement`.

See Also:
  - `TryStatement`
  - Constant Field Values

### TYPE_DECLARATION

public static final int TYPE_DECLARATION
Node type constant indicating a node of type `TypeDeclaration`.

See Also:
  - `TypeDeclaration`
  - Constant Field Values

### TYPE_DECLARATION_STATEMENT

public static final int TYPE_DECLARATION_STATEMENT
Node type constant indicating a node of type `TypeDeclarationStatement`.

See Also:
  - `TypeDeclarationStatement`
  - Constant Field Values

### TYPE_LITERAL

public static final int TYPE_LITERAL
Node type constant indicating a node of type `TypeLiteral`.

See Also:
  - `TypeLiteral`
  - Constant Field Values

### VARIABLE_DECLARATION_EXPRESSION

public static final int VARIABLE_DECLARATION_EXPRESSION
Node type constant indicating a node of type `VariableDeclarationExpression`.

See Also:
  - `VariableDeclarationExpression`
  - Constant Field Values

### VARIABLE_DECLARATION_FRAGMENT

public static final int VARIABLE_DECLARATION_FRAGMENT
Node type constant indicating a node of type `VariableDeclarationFragment`.

See Also:
  - `VariableDeclarationFragment`
  - Constant Field Values

### VARIABLE_DECLARATION_STATEMENT

public static final int VARIABLE_DECLARATION_STATEMENT
Node type constant indicating a node of type `VariableDeclarationStatement`.

See Also:
  - `VariableDeclarationStatement`
  - Constant Field Values

### WHILE_STATEMENT

public static final int WHILE_STATEMENT
Node type constant indicating a node of type `WhileStatement`.

See Also:
  - `WhileStatement`
  - Constant Field Values

### INSTANCEOF_EXPRESSION

public static final int INSTANCEOF_EXPRESSION
Node type constant indicating a node of type `InstanceofExpression`.

See Also:
  - `InstanceofExpression`
  - Constant Field Values

### LINE_COMMENT

public static final int LINE_COMMENT
Node type constant indicating a node of type `LineComment`.

Since:
  3.0
See Also:
  - `LineComment`
  - Constant Field Values

### BLOCK_COMMENT

public static final int BLOCK_COMMENT
Node type constant indicating a node of type `BlockComment`.

Since:
  3.0
See Also:
  - `BlockComment`
  - Constant Field Values

### TAG_ELEMENT

public static final int TAG_ELEMENT
Node type constant indicating a node of type `TagElement`.

Since:
  3.0
See Also:
  - `TagElement`
  - Constant Field Values

### TEXT_ELEMENT

public static final int TEXT_ELEMENT
Node type constant indicating a node of type `TextElement`.

Since:
  3.0
See Also:
  - `TextElement`
  - Constant Field Values

### MEMBER_REF

public static final int MEMBER_REF
Node type constant indicating a node of type `MemberRef`.

Since:
  3.0
See Also:
  - `MemberRef`
  - Constant Field Values

### METHOD_REF

public static final int METHOD_REF
Node type constant indicating a node of type `MethodRef`.

Since:
  3.0
See Also:
  - `MethodRef`
  - Constant Field Values

### METHOD_REF_PARAMETER

public static final int METHOD_REF_PARAMETER
Node type constant indicating a node of type `MethodRefParameter`.

Since:
  3.0
See Also:
  - `MethodRefParameter`
  - Constant Field Values

### ENHANCED_FOR_STATEMENT

public static final int ENHANCED_FOR_STATEMENT
Node type constant indicating a node of type `EnhancedForStatement`.

Since:
  3.1
See Also:
  - `EnhancedForStatement`
  - Constant Field Values

### ENUM_DECLARATION

public static final int ENUM_DECLARATION
Node type constant indicating a node of type `EnumDeclaration`.

Since:
  3.1
See Also:
  - `EnumDeclaration`
  - Constant Field Values

### ENUM_CONSTANT_DECLARATION

public static final int ENUM_CONSTANT_DECLARATION
Node type constant indicating a node of type `EnumConstantDeclaration`.

Since:
  3.1
See Also:
  - `EnumConstantDeclaration`
  - Constant Field Values

### TYPE_PARAMETER

public static final int TYPE_PARAMETER
Node type constant indicating a node of type `TypeParameter`.

Since:
  3.1
See Also:
  - `TypeParameter`
  - Constant Field Values

### PARAMETERIZED_TYPE

public static final int PARAMETERIZED_TYPE
Node type constant indicating a node of type `ParameterizedType`.

Since:
  3.1
See Also:
  - `ParameterizedType`
  - Constant Field Values

### QUALIFIED_TYPE

public static final int QUALIFIED_TYPE
Node type constant indicating a node of type `QualifiedType`.

Since:
  3.1
See Also:
  - `QualifiedType`
  - Constant Field Values

### WILDCARD_TYPE

public static final int WILDCARD_TYPE
Node type constant indicating a node of type `WildcardType`.

Since:
  3.1
See Also:
  - `WildcardType`
  - Constant Field Values

### NORMAL_ANNOTATION

public static final int NORMAL_ANNOTATION
Node type constant indicating a node of type `NormalAnnotation`.

Since:
  3.1
See Also:
  - `NormalAnnotation`
  - Constant Field Values

### MARKER_ANNOTATION

public static final int MARKER_ANNOTATION
Node type constant indicating a node of type `MarkerAnnotation`.

Since:
  3.1
See Also:
  - `MarkerAnnotation`
  - Constant Field Values

### SINGLE_MEMBER_ANNOTATION

public static final int SINGLE_MEMBER_ANNOTATION
Node type constant indicating a node of type `SingleMemberAnnotation`.

Since:
  3.1
See Also:
  - `SingleMemberAnnotation`
  - Constant Field Values

### MEMBER_VALUE_PAIR

public static final int MEMBER_VALUE_PAIR
Node type constant indicating a node of type `MemberValuePair`.

Since:
  3.1
See Also:
  - `MemberValuePair`
  - Constant Field Values

### ANNOTATION_TYPE_DECLARATION

public static final int ANNOTATION_TYPE_DECLARATION
Node type constant indicating a node of type `AnnotationTypeDeclaration`.

Since:
  3.1
See Also:
  - `AnnotationTypeDeclaration`
  - Constant Field Values

### ANNOTATION_TYPE_MEMBER_DECLARATION

public static final int ANNOTATION_TYPE_MEMBER_DECLARATION
Node type constant indicating a node of type `AnnotationTypeMemberDeclaration`.

Since:
  3.1
See Also:
  - `AnnotationTypeMemberDeclaration`
  - Constant Field Values

### MODIFIER

public static final int MODIFIER
Node type constant indicating a node of type `Modifier`.

Since:
  3.1
See Also:
  - `Modifier`
  - Constant Field Values

### UNION_TYPE

public static final int UNION_TYPE
Node type constant indicating a node of type `UnionType`.

Since:
  3.7.1
See Also:
  - `UnionType`
  - Constant Field Values

### DIMENSION

public static final int DIMENSION
Node type constant indicating a node of type `Dimension`.

Since:
  3.10
See Also:
  - `Dimension`
  - Constant Field Values

### LAMBDA_EXPRESSION

public static final int LAMBDA_EXPRESSION
Node type constant indicating a node of type `LambdaExpression`.

Since:
  3.10
See Also:
  - `LambdaExpression`
  - Constant Field Values

### INTERSECTION_TYPE

public static final int INTERSECTION_TYPE
Node type constant indicating a node of type `IntersectionType`.

Since:
  3.10
See Also:
  - `IntersectionType`
  - Constant Field Values

### NAME_QUALIFIED_TYPE

public static final int NAME_QUALIFIED_TYPE
Node type constant indicating a node of type `NameQualifiedType`.

Since:
  3.10
See Also:
  - `NameQualifiedType`
  - Constant Field Values

### CREATION_REFERENCE

public static final int CREATION_REFERENCE
Node type constant indicating a node of type `CreationReference`.

Since:
  3.10
See Also:
  - `CreationReference`
  - Constant Field Values

### EXPRESSION_METHOD_REFERENCE

public static final int EXPRESSION_METHOD_REFERENCE
Node type constant indicating a node of type `ExpressionMethodReference`.

Since:
  3.10
See Also:
  - `ExpressionMethodReference`
  - Constant Field Values

### SUPER_METHOD_REFERENCE

public static final int SUPER_METHOD_REFERENCE
Node type constant indicating a node of type `SuperMethhodReference`.

Since:
  3.10
See Also:
  - `SuperMethodReference`
  - Constant Field Values

### TYPE_METHOD_REFERENCE

public static final int TYPE_METHOD_REFERENCE
Node type constant indicating a node of type `TypeMethodReference`.

Since:
  3.10
See Also:
  - `TypeMethodReference`
  - Constant Field Values

### MODULE_DECLARATION

public static final int MODULE_DECLARATION
Node type constant indicating a node of type `ModuleDeclaration`.

Since:
  3.14
See Also:
  - `ModuleDeclaration`
  - Constant Field Values

### REQUIRES_DIRECTIVE

public static final int REQUIRES_DIRECTIVE
Node type constant indicating a node of type `RequiresDirective`.

Since:
  3.14
See Also:
  - `RequiresDirective`
  - Constant Field Values

### EXPORTS_DIRECTIVE

public static final int EXPORTS_DIRECTIVE
Node type constant indicating a node of type `ExportsDirective`.

Since:
  3.14
See Also:
  - `ExportsDirective`
  - Constant Field Values

### OPENS_DIRECTIVE

public static final int OPENS_DIRECTIVE
Node type constant indicating a node of type `OpensDirective`.

Since:
  3.14
See Also:
  - `OpensDirective`
  - Constant Field Values

### USES_DIRECTIVE

public static final int USES_DIRECTIVE
Node type constant indicating a node of type `UsesDirective`.

Since:
  3.14
See Also:
  - `UsesDirective`
  - Constant Field Values

### PROVIDES_DIRECTIVE

public static final int PROVIDES_DIRECTIVE
Node type constant indicating a node of type `ProvidesDirective`.

Since:
  3.14
See Also:
  - `ProvidesDirective`
  - Constant Field Values

### MODULE_MODIFIER

public static final int MODULE_MODIFIER
Node type constant indicating a node of type `ModuleModifier`.

Since:
  3.14
See Also:
  - `ModuleModifier`
  - Constant Field Values

### SWITCH_EXPRESSION

public static final int SWITCH_EXPRESSION
Node type constant indicating a node of type `SwitchExpression`.

Since:
  3.18
See Also:
  - `SwitchExpression`
  - Constant Field Values

### YIELD_STATEMENT

public static final int YIELD_STATEMENT
Node type constant indicating a node of type `YieldStatement`.

Since:
  3.20
See Also:
  - `YieldStatement`
  - Constant Field Values

### TEXT_BLOCK

public static final int TEXT_BLOCK
Node type constant indicating a node of type `TextBlock`.

Since:
  3.20
See Also:
  - `TextBlock`
  - Constant Field Values

### RECORD_DECLARATION

public static final int RECORD_DECLARATION
Node type constant indicating a node of type `RecordDeclaration`.

Since:
  3.22
See Also:
  - `RecordDeclaration`
  - Constant Field Values

### PATTERN_INSTANCEOF_EXPRESSION

public static final int PATTERN_INSTANCEOF_EXPRESSION
Node type constant indicating a node of type `PatternInstanceofExpression`.

Since:
  3.26
See Also:
  - `PatternInstanceofExpression`
  - Constant Field Values

### MODULE_QUALIFIED_NAME

public static final int MODULE_QUALIFIED_NAME
Node type constant indicating a node of type `ModuleQualifiedName`.

Since:
  3.24
See Also:
  - `ModuleQualifiedName`
  - Constant Field Values

### TYPE_PATTERN

public static final int TYPE_PATTERN
Node type constant indicating a node of type `TypePattern`.

Since:
  3.28
See Also:
  - `TypePattern`
  - Constant Field Values

### GUARDED_PATTERN

public static final int GUARDED_PATTERN
Node type constant indicating a node of type `GuardedPattern`.

Since:
  3.28
See Also:
  - `GuardedPattern`
  - Constant Field Values

### NULL_PATTERN

public static final int NULL_PATTERN
Node type constant indicating a node of type `NullPattern`.

Since:
  3.28
See Also:
  - `NullPattern`
  - Constant Field Values

### CASE_DEFAULT_EXPRESSION

public static final int CASE_DEFAULT_EXPRESSION
Node type constant indicating a node of type `CaseDefaultExpression`.

Since:
  3.28
See Also:
  - `CaseDefaultExpression`
  - Constant Field Values

### TAG_PROPERTY

public static final int TAG_PROPERTY
Node type constant indicating a node of type `TagProperty`.

Since:
  3.30
See Also:
  - `TagProperty`
  - Constant Field Values

### JAVADOC_REGION

public static final int JAVADOC_REGION
Node type constant indicating a node of type `JavaDocRegion`.

Since:
  3.30
See Also:
  - `JavaDocRegion`
  - Constant Field Values

### JAVADOC_TEXT_ELEMENT

public static final int JAVADOC_TEXT_ELEMENT
Node type constant indicating a node of type `TextElement`.

Since:
  3.31
See Also:
  - `TextElement`
  - Constant Field Values

### RECORD_PATTERN

public static final int RECORD_PATTERN
Node type constant indicating a node of type `RecordPattern`.

Since:
  3.32
See Also:
  - `RecordPattern`
  - Constant Field Values

### STRING_TEMPLATE_EXPRESSION

public static final int STRING_TEMPLATE_EXPRESSION
Node type constant indicating a node of type `StringTemplateExpression`.

Since:
  3.37
See Also:
  - `TemplateExpression`
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### STRING_FRAGMENT

public static final int STRING_FRAGMENT
Node type constant indicating a node of type `StringFragment`.

Since:
  3.37
See Also:
  - `StringLiteral`
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### STRING_TEMPLATE_COMPONENT

public static final int STRING_TEMPLATE_COMPONENT
Node type constant indicating a node of type `StringTemplateComponent`.

Since:
  3.37
See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### EitherOr_MultiPattern

public static final int EitherOr_MultiPattern
Node type constant indicating a node of type `EitherOrMultiPattern`.

Since:
  3.38
See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### UNNAMED_CLASS

public static final int UNNAMED_CLASS

Since:
  3.38
See Also:
  - `ImplicitTypeDeclaration`
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### MALFORMED

public static final int MALFORMED
Flag constant (bit mask, value 1) indicating that there is something not quite right with this AST node.

The standard parser (`ASTParser`) sets this flag on a node to indicate a syntax error detected in the vicinity.

See Also:
  - Constant Field Values

### ORIGINAL

public static final int ORIGINAL
Flag constant (bit mask, value 2) indicating that this is a node that was created by the parser (as opposed to one created by another party).

The standard parser (`ASTParser`) sets this flag on the nodes it creates.

Since:
  3.0
See Also:
  - Constant Field Values

### PROTECT

public static final int PROTECT
Flag constant (bit mask, value 4) indicating that this node is unmodifiable. When a node is marked unmodifiable, the following operations result in a runtime exception:

- Change a simple property of this node.
- Add or remove a child node from this node.
- Parent (or reparent) this node.

The standard parser (`ASTParser`) does not set this flag on the nodes it creates. However, clients may set this flag on a node to prevent further modification of the its structural properties.

Since:
  3.0
See Also:
  - Constant Field Values

### RECOVERED

public static final int RECOVERED
Flag constant (bit mask, value 8) indicating that this node or a part of this node is recovered from source that contains a syntax error detected in the vicinity.

The standard parser (`ASTParser`) sets this flag on a node to indicate a recovered node.

Since:
  3.2
See Also:
  - Constant Field Values

## Method Details

### nodeClassForType

public static Class nodeClassForType(int nodeType)
Returns the node class for the corresponding node type.

Parameters:
  `nodeType` - AST node type
Returns:
  the corresponding `ASTNode` subclass
Throws:
  `IllegalArgumentException` - if `nodeType` is not a legal AST node type
Since:
  3.0
See Also:
  - `getNodeType()`

### getAST

public final AST getAST()
Returns this node's AST.

Note that the relationship between an AST node and its owing AST does not change over the lifetime of a node.

Returns:
  the AST that owns this node

### getParent

public final ASTNode getParent()
Returns this node's parent node, or `null` if this is the root node.

Note that the relationship between an AST node and its parent node may change over the lifetime of a node.

Returns:
  the parent of this node, or `null` if none

### getLocationInParent

public final StructuralPropertyDescriptor getLocationInParent()
Returns the location of this node within its parent, or `null` if this is a root node.

     ASTNode node = ...;
     ASTNode parent = node.getParent();
     StructuralPropertyDescriptor location = node.getLocationInParent();
     assert (parent != null) == (location != null);
     if ((location != null) && location.isChildProperty())
        assert parent.getStructuralProperty(location) == node;
     if ((location != null) && location.isChildListProperty())
        assert ((List) parent.getStructuralProperty(location)).contains(node);

Note that the relationship between an AST node and its parent node may change over the lifetime of a node.

Returns:
  the location of this node in its parent, or `null` if this node has no parent
Since:
  3.0

### getRoot

public final ASTNode getRoot()
Returns the root node at or above this node; returns this node if it is a root.

Returns:
  the root node at or above this node

### getStructuralProperty

public final Object getStructuralProperty(StructuralPropertyDescriptor property)
Returns the value of the given structural property for this node. The value returned depends on the kind of property:

- `SimplePropertyDescriptor` - the value of the given simple property, or `null` if none; primitive values are "boxed"
- `ChildPropertyDescriptor` - the child node (type `ASTNode`), or `null` if none
- `ChildListPropertyDescriptor` - the list (element type: `ASTNode`)

Parameters:
  `property` - the property
Returns:
  the value, or `null` if none
Throws:
  `RuntimeException` - if this node does not have the given property
Since:
  3.0

### setStructuralProperty

public final void setStructuralProperty(StructuralPropertyDescriptor property, Object value)
Sets the value of the given structural property for this node. The value passed depends on the kind of property:

- `SimplePropertyDescriptor` - the new value of the given simple property, or `null` if none; primitive values are "boxed"
- `ChildPropertyDescriptor` - the new child node (type `ASTNode`), or `null` if none
- `ChildListPropertyDescriptor` - not allowed

Parameters:
  `property` - the property
  `value` - the property value
Throws:
  `RuntimeException` - if this node does not have the given property, or if the given property cannot be set
Since:
  3.0

### structuralPropertiesForType

public final List structuralPropertiesForType()
Returns a list of structural property descriptors for nodes of the same type as this node. Clients must not modify the result.

Note that property descriptors are a meta-level mechanism for manipulating ASTNodes in a generic way. They are unrelated to `get/setProperty`.

Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)
Since:
  3.0

### delete

public final void delete()
Removes this node from its parent. Has no effect if this node is unparented. If this node appears as an element of a child list property of its parent, then this node is removed from the list using `List.remove`. If this node appears as the value of a child property of its parent, then this node is detached from its parent by passing `null` to the appropriate setter method; this operation fails if this node is in a mandatory property.

Since:
  3.0

### getProperty

public final Object getProperty(String propertyName)
Returns the value of the named property of this node, or `null` if none.

Parameters:
  `propertyName` - the property name
Returns:
  the property value, or `null` if none
See Also:
  - `setProperty(String,Object)`

### setProperty

public final void setProperty(String propertyName, Object data)
Sets the named property of this node to the given value, or to `null` to clear it.

Clients should employ property names that are sufficiently unique to avoid inadvertent conflicts with other clients that might also be setting properties on the same node.

Note that modifying a property is not considered a modification to the AST itself. This is to allow clients to decorate existing nodes with their own properties without jeopardizing certain things (like the validity of bindings), which rely on the underlying tree remaining static.

Parameters:
  `propertyName` - the property name
  `data` - the new property value, or `null` if none
Throws:
  `IllegalArgumentException` - if the given property name is `null`
See Also:
  - `getProperty(String)`

### properties

public final Map properties()
Returns an unmodifiable table of the properties of this node with non-`null` values.

Returns:
  the table of property values keyed by property name (key type: `String`; value type: `Object`)

### getFlags

public final int getFlags()
Returns the flags associated with this node.

No flags are associated with newly created nodes.

The flags are the bitwise-or of individual flags. The following flags are currently defined:

- `MALFORMED` - indicates node is syntactically malformed
- `ORIGINAL` - indicates original node created by ASTParser
- `PROTECT` - indicates node is protected from further modification
- `RECOVERED` - indicates node or a part of this node is recovered from source that contains a syntax error

Other bit positions are reserved for future use.

Returns:
  the bitwise-or of individual flags
See Also:
  - `setFlags(int)`

### setFlags

public final void setFlags(int flags)
Sets the flags associated with this node to the given value.

The flags are the bitwise-or of individual flags. The following flags are currently defined:

- `MALFORMED` - indicates node is syntactically malformed
- `ORIGINAL` - indicates original node created by ASTParser
- `PROTECT` - indicates node is protected from further modification
- `RECOVERED` - indicates node or a part of this node is recovered from source that contains a syntax error

Other bit positions are reserved for future use.

Note that the flags are not considered a structural property of the node, and can be changed even if the node is marked as protected.

Parameters:
  `flags` - the bitwise-or of individual flags
See Also:
  - `getFlags()`

### getNodeType

public final int getNodeType()
Returns an integer value identifying the type of this concrete AST node. The values are small positive integers, suitable for use in switch statements.

For each concrete node type there is a unique node type constant (name and value). The unique node type constant for a concrete node type such as `CastExpression` is `ASTNode.CAST_EXPRESSION`.

Returns:
  one of the node type constants

### equals

public final boolean equals(Object obj)
The `ASTNode` implementation of this `Object` method uses object identity (==). Use `subtreeMatch` to compare two subtrees for equality.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` -
Returns:
See Also:
  - `subtreeMatch(ASTMatcher matcher, Object other)`

### hashCode

public final int hashCode()

Overrides:
  `hashCode` in class `Object`

### subtreeMatch

public final boolean subtreeMatch(ASTMatcher matcher, Object other)
Returns whether the subtree rooted at the given node matches the given other object as decided by the given matcher.

Parameters:
  `matcher` - the matcher
  `other` - the other object, or `null`
Returns:
  `true` if the subtree matches, or `false` if they do not match

### copySubtree

public static ASTNode copySubtree(AST target, ASTNode node)
Returns a deep copy of the subtree of AST nodes rooted at the given node. The resulting nodes are owned by the given AST, which may be different from the ASTs of the given node. Even if the given node has a parent, the result node will be unparented.

Source range information on the original nodes is automatically copied to the new nodes. Client properties (`properties`) are not carried over.

The node's `AST` and the target `AST` must support the same API level.

Parameters:
  `target` - the AST that is to own the nodes in the result
  `node` - the node to copy, or `null` if none
Returns:
  the copied node, or `null` if `node` is `null`

### copySubtrees

public static List copySubtrees(AST target, List nodes)
Returns a deep copy of the subtrees of AST nodes rooted at the given list of nodes. The resulting nodes are owned by the given AST, which may be different from the ASTs of the nodes in the list. Even if the nodes in the list have parents, the nodes in the result will be unparented.

Source range information on the original nodes is automatically copied to the new nodes. Client properties (`properties`) are not carried over.

Parameters:
  `target` - the AST that is to own the nodes in the result
  `nodes` - the list of nodes to copy (element type: `ASTNode`)
Returns:
  the list of copied subtrees (element type: `ASTNode`)

### accept

public final void accept(ASTVisitor visitor)
Accepts the given visitor on a visit of the current node.

Parameters:
  `visitor` - the visitor object
Throws:
  `IllegalArgumentException` - if the visitor is null

### getStartPosition

public final int getStartPosition()
Returns the character index into the original source file indicating where the source fragment corresponding to this node begins.

The parser supplies useful well-defined source ranges to the nodes it creates. See `ASTParser.setKind(int)` for details on precisely where source ranges begin and end.

Returns:
  the 0-based character index, or `-1` if no source position information is recorded for this node
See Also:
  - `getLength()`
  - `ASTParser`

### getLength

public final int getLength()
Returns the length in characters of the original source file indicating where the source fragment corresponding to this node ends.

The parser supplies useful well-defined source ranges to the nodes it creates. See `ASTParser.setKind(int)` methods for details on precisely where source ranges begin and end.

Returns:
  a (possibly 0) length, or `0` if no source position information is recorded for this node
See Also:
  - `getStartPosition()`
  - `ASTParser`

### setSourceRange

public final void setSourceRange(int startPosition, int length)
Sets the source range of the original source file where the source fragment corresponding to this node was found.

See `ASTParser.setKind(int)` for details on precisely where source ranges are supposed to begin and end.

Parameters:
  `startPosition` - a 0-based character index, or `-1` if no source position information is available for this node
  `length` - a (possibly 0) length, or `0` if no source position information is recorded for this node
See Also:
  - `getStartPosition()`
  - `getLength()`
  - `ASTParser`

### toString

public final String toString()
Returns a string representation of this node suitable for debugging purposes only.

Overrides:
  `toString` in class `Object`
Returns:
  a debug string

### subtreeBytes

public final int subtreeBytes()
Returns an estimate of the memory footprint in bytes of the entire subtree rooted at this node.

Returns:
  the size of this subtree in bytes